
CON
    _clkmode = xtal1 + pll16x           'Set up the Clock, this is for 80MHz 
    _xinfreq = 5_000_000



VAR
  byte  rxString[50]  'Holds [50] incoming serial bytes, 
                      'that should hold 49 letters or numbers, and the terminator char. 
        
  
 
OBJ        
   pst : "Parallax Serial terminal"     'Maybe They should Name it "Propeller Serial Terminal" instead??...
  
  'HomeBrew : "Brew Tender 9000"       'You can add as many Spin Programs as You want!!
  
PUB Main   ''Starts up all the action
  pst.StartRxTx(31, 30, 0, 57600)   'Gotta start the Parallax Serial Terminal up before You make any calls to it.
 
  repeat
    pst.RxFlush            'Adding this here, allows bad/old input to be reset, and make room for new input.
                                                        
    pst.StrIn(@rxString)   'Recieve the String from PC, and place it starting at (@rxString) for [50] byte's..
    
    
            { Compare the received string to the DAT strings, Then do something cool }
    
     if( strcomp(@rxString, @led8) )  'This compares the string at (rxString), with the one at (led8), decides IF its the same,
                                      'Or different, IF it's the same, Then stay, IF it's different then move on to next IF in line. 
                                      'STRCOMP (StringAddress1, StringAddress2 ) is in the "Memory" section of the Propeller Manual.
                                      'Right where You would expect to find it,..but not where I expected to find it...sigh..
                                      'Note to self: Reread the manual, this time pay attention...
                                                                            
                                       
        Toggle(8)     'Toggle(pin#) jumps to the Toggle routine, flashes the chosen Led 50 times and comes back to the next line
                     
        pst.RxFlush   'This Flushes the Input Buffer, so the next data sent will be not be mixed up with the old data.
                        
        next          'Skip remaining statements and start over from the top repeat.
      

                         'lather rinse and repeat (but only 8 pins for now)...Hrmm..(PropellerII, 100 pins??? Yeesh!!)...
                         'gotta be a better way than this, Gonna Have to read up on Indexing Stuff,
                         'But this is not to bad for 8 pins.

                                     
    if( strcomp(@rxString, @led9) )
      Toggle(9)
      pst.RxFlush
      next

    if( strcomp(@rxString, @led10) )
      Toggle(10)
      pst.RxFlush
      next

    if( strcomp(@rxString, @led11) )
      Toggle(11)  '<<<<<<<<<<<<<<<<<<<<<<No reason a different action could not be called here..
      
      'RotateServo(360') <<<<<<<<<<<<<<<<You can add any amount of procedures/functions,
      
      'HomeBrew.HeatMash <<<<<<<<<<<<<<<<And coolest of all, add whole different Spin Programs.
        
      pst.RxFlush
      next        

    if( strcomp(@rxString, @led12) )
      Toggle(12)
      pst.RxFlush
      next
      
    if( strcomp(@rxString, @led13) )
      Toggle(13) 
      pst.RxFlush
      next
      
    if( strcomp(@rxString, @led14) )
      Toggle(14)
      pst.RxFlush
      next

    if( strcomp(@rxString, @led15) )                
      Toggle(15) 
      pst.RxFlush
      next

    'if( strcomp(@rxString, @led16) )                
      'Toggle(16)                     'You could go on and on till You got tired or ran out of things for Your Pins to do..
      'pst.RxFlush                           
      'next


                                'The end of the IF's, this is kinda like Else IF, except You don't have to type "Else IF"
    ElectricShock               'This is what You want to do if You get bad data or something the program does not expect.      
                                               '!!!DO NOT SEND DATA THE PROPELLER DOES NOT EXPECT!!!
                                             '(it will do bad things if You send garbage from the PC.)
          
         
PUB Toggle(pin)    ''Toggle the Selected Pin as Selected on the PC
  dira[pin]~~
  repeat 50                    
    !outa[pin]
    waitcnt(3_000_000 + cnt)
    
PUB ElectricShock  ''Use Your favorite Capacitor to Metal Chair circiut,
                   'and adjust the voltage as needed

  dira[8..15]~~
  
  pst.str(@WrongData)
  
  repeat 50                   
    !outa[8..15]
    waitcnt(3_000_000 + cnt)
    
    
DAT       ''Line up all the expected Strings 
           'I still gotta learn up on indexing stuff     

        led8 byte "LED8", 0
        led9 byte "LED9", 0
        led10 byte "LED10", 0
        led11 byte "LED11", 0
        led12 byte "LED12", 0    
        led13 byte "LED13", 0
        led14 byte "LED14", 0 
        led15 byte "LED15", 0
        WrongData Byte "Don't Hand Me that Garbage",0
      